/*
 * File:   main.c
 * Author: krikzz
 *
 * Created on 23.06.2010
 */


#include "../../lib/edos.h"
extern u32 font_base[];

u16 cy;

Sprite ball;


#define BORDER_X 3
#define BORDER_Y 2
#define FIELD_X BORDER_X
#define FIELD_Y BORDER_Y


#define FIELD_W (40 - BORDER_X * 2)
#define FIELD_H (28 - BORDER_Y * 2)

#define BOARD_H 4
#define LATENCY 18


u8 game();
u8 connect();

u8 tile_buff[256];


u16 joy_buff[LATENCY];
u16 is_p1;

int main() {


    u16 i;
    u8 resp;


    edInit();

    VDP_init(1);
    VDP_loadFont(font_base, 0);
    VDP_setPaletteColor(0, 15, 0xfff); //font color
    VDP_setPaletteColor(0, 1, 0xfff); //font color
    VDP_setPaletteColor(0, 2, 0x0ff); //font color
    VDP_setPaletteColor(0, 3, 0x222); //font color
    JOY_init();


    //for (i = 0; i < 32; i++)buff[i] = 0x00;

    ((u32 *) tile_buff)[0] = 0;
    ((u32 *) tile_buff)[1] = 0x00111100;
    ((u32 *) tile_buff)[2] = 0x01111110;
    ((u32 *) tile_buff)[3] = 0x01111110;
    ((u32 *) tile_buff)[4] = 0x01111110;
    ((u32 *) tile_buff)[5] = 0x01111110;
    ((u32 *) tile_buff)[6] = 0x00111100;
    ((u32 *) tile_buff)[7] = 0;



    for (i = 0; i < 32; i++)tile_buff[i + 32] = 0x22;
    for (i = 0; i < 32; i++)tile_buff[i + 64] = 0x33;
    VDP_DoDMA(VDP_DMA_VRAM, tile_buff, 32, 32 * 3);


    for (;;) {

        cy = 2;
        VDP_fillTileRect(APLAN, 0, 0, 0, 40, 28);
        VDP_fillTileRect(BPLAN, 0, 0, 0, 40, 28);

        resp = connect();

        if (resp) {
            VDP_drawText(APLAN, "error", 0, 2, cy++);
            while (joy == 0);
            while (joy != 0);
            continue;
        }

        VDP_fillTileRect(APLAN, 0, 0, 0, 40, 28);
        VDP_fillTileRect(BPLAN, 0, 0, 0, 40, 28);
        game();
        VDP_fillTileRect(APLAN, 0, 0, 0, 40, 28);
        VDP_fillTileRect(BPLAN, 0, 0, 0, 40, 28);
        VDP_drawText(APLAN, "connection lost", 0, 2, 2);
        while (joy == 0);
        while (joy != 0);
    }


    return 0;
}

u8 connect() {


    u16 i;
    u32 resp;
    u64 my_serial;
    u64 serial;

    VDP_drawText(APLAN, "prepare socket...", 0, 2, cy++);
    resp = ed_os->osSocketClose();
    if (resp)return resp;
    VDP_drawText(APLAN, "connect to server...", 0, 2, cy++);
    resp = ed_os->osSocketConnect("31.135.144.51", 8888);
    if (resp)return resp;
    VDP_drawText(APLAN, "ok", 0, 2, cy++);

    VDP_drawText(APLAN, "waiting...", 0, 2, cy++);

    resp = ed_os->osSocketWrite("*", 1, 0);
    if (resp != 1)return 10;

    resp = ed_os->usbReadByte();
    if (resp != '*')return 11;

    ed_os->osGetSerial(&my_serial);
    ed_os->osSocketWrite(&my_serial, 8, 0);
    ed_os->osSocketRead(&serial, 8, 0);

    if (serial > my_serial) {
        is_p1 = 1;
    } else {
        is_p1 = 0;
    }

    for (i = 0; i < LATENCY; i++) {
        joy_buff[i] = 0;
    }
    resp = ed_os->osSocketWrite(joy_buff, LATENCY * 2, 0);
    if (resp != LATENCY * 2)return 12;

    return 0;
}

u8 game() {


    u16 i = 0;


    u16 ball_x = 0;
    u16 ball_y = 0;
    s16 ball_sx = 3;
    s16 ball_sy = 1;
    u16 joy1 = 0;
    u16 joy2 = 0;
    s16 py1 = 0;
    s16 py2 = 0;
    s16 spdy = 0;
    u16 defeat = 0;
    u16 score[2];
    u8 num[3];
    u8 ctr = 0;
    u16 joy_tmp;
    u16 f_ctr = 0;
    //u16 f_ctr2 = 0;
    //VDP_vintOff();

    for (i = 0; i < 20; i++) {
        VDP_setVerticalScroll(APLAN, i, 0);
        VDP_setVerticalScroll(BPLAN, i, 0);
    }

    VDP_fillTileRect(APLAN, 2, FIELD_X - 1, 0, 1, BOARD_H);
    VDP_fillTileRect(APLAN, 2, FIELD_X + FIELD_W, 0, 1, BOARD_H);
    VDP_setReg(11, 4);
    VDP_addSprite((u16*) & ball, 32, 32, SPRITE_SIZE(1, 1), 1, 0);
    score[0] = 0;
    score[1] = 0;
    num[2] = 0;

    joy1 = 0;
    joy2 = 0;


    for (;;) {


        if (joy1 == 0 && joy2 == 0 && defeat == 0)f_ctr++;

        f_ctr %= 10000;

        num[0] = f_ctr / 1000 % 10 + '0';
        num[1] = f_ctr / 100 % 10 + '0';
        VDP_drawText(APLAN, num, 0, 18, FIELD_Y - 1);

        num[0] = f_ctr / 10 % 10 + '0';
        num[1] = f_ctr % 10 + '0';
        VDP_drawText(APLAN, num, 0, 20, FIELD_Y - 1);

        //joy = JOY_readJoypad(0);
        joy_tmp = joy;
        spdy++;
        if (spdy > 3)spdy = 1;

        ed_os->osSocketWrite(&joy_tmp, 2, 0);
        if (is_p1) {
            joy1 = joy_buff[ctr];
            ed_os->osSocketRead(&joy2, 2, 0);
        } else {
            ed_os->osSocketRead(&joy1, 2, 0);
            joy2 = joy_buff[ctr];
        }
        joy_buff[ctr] = joy_tmp;


        ctr++;
        ctr %= LATENCY;

        if ((joy1 & BUTTON_UP))py1 -= 2;
        if ((joy1 & BUTTON_DOWN))py1 += 2;
        if (py1 < FIELD_Y * 8)py1 = FIELD_Y * 8;
        if (py1 + BOARD_H * 8 > (FIELD_Y + FIELD_H) * 8)py1 = (FIELD_Y + FIELD_H) * 8 - BOARD_H * 8;

        if ((joy2 & BUTTON_UP))py2 -= 2;
        if ((joy2 & BUTTON_DOWN))py2 += 2;
        if (py2 < FIELD_Y * 8)py2 = FIELD_Y * 8;
        if (py2 + BOARD_H * 8 > (FIELD_Y + FIELD_H) * 8)py2 = (FIELD_Y + FIELD_H) * 8 - BOARD_H * 8;
        i++;

        if (defeat == 0) {
            ball_x += ball_sx;
            ball_y += ball_sy;
        } else {
            defeat--;
        }


        if (ball_x <= FIELD_X * 8 || ball_x >= (FIELD_X + FIELD_W) * 8) {

            ball_x = ball_x <= FIELD_X * 8 ? FIELD_X * 8 : (FIELD_X + FIELD_W) * 8;
            if (ball_sy == 0)ball_sy = 1;

            if (ball_sx < 0) {
                if (ball_y + 4 >= py1 && ball_y - 4 <= py1 + BOARD_H * 8) {

                    if ((joy1 & BUTTON_UP))ball_sy = -spdy;
                    if ((joy1 & BUTTON_DOWN))ball_sy = spdy;
                } else {

                    ball_x = (FIELD_X + FIELD_W / 2)*8;
                    ball_y = (FIELD_Y + FIELD_H / 2)*8;
                    ball_sy = 0;
                    defeat = 32;
                    score[1]++;
                }
            } else {


                if (ball_y + 4 >= py2 && ball_y - 4 <= py2 + BOARD_H * 8) {
                    //ball_sx = -ball_sx;
                    if ((joy2 & BUTTON_UP))ball_sy = -spdy;
                    if ((joy2 & BUTTON_DOWN))ball_sy = spdy;
                } else {

                    ball_x = (FIELD_X + FIELD_W / 2)*8;
                    ball_y = (FIELD_Y + FIELD_H / 2)*8;
                    ball_sy = 0;
                    defeat = 32;
                    score[0]++;
                }

            }
            ball_sx = -ball_sx;

        }

        if (ball_y <= FIELD_Y * 8 || ball_y >= (FIELD_Y + FIELD_H) * 8) {
            ball_y = ball_y <= FIELD_Y * 8 ? FIELD_Y * 8 : (FIELD_Y + FIELD_H) * 8;
            ball_sy = -ball_sy;
        }

        ball.x = ball_x + 0x80 - 4;
        ball.y = ball_y + 0x80 - 4;
        VDP_waitVSync();
        VDP_setVerticalScroll(APLAN, 1, -py1);
        VDP_setVerticalScroll(APLAN, 18, -py2);
        VDP_spriteBuffToVram((u16 *) & ball, 1);

        num[0] = score[0] / 10 % 10 + '0';
        num[1] = score[0] % 10 + '0';
        VDP_drawText(APLAN, num, 0, FIELD_X + 2, FIELD_Y - 1);

        num[0] = score[1] / 10 % 10 + '0';
        num[1] = score[1] % 10 + '0';
        VDP_drawText(APLAN, num, 0, FIELD_X + FIELD_W - 4, FIELD_Y - 1);
        // if (defeat)for (i = 0; i < 32; i++)VDP_waitVSync();
        // defeat = 0;

    }

    return 0;
}

void vb() {

    joy = JOY_readJoypad(0);
}

void hb() {
    //hblank interrupt
}

void in() {
    //all other interrupts
}
